//
// Created by q1w2e3r4 on 23-7-9.
//
#include "codegen/AsmBuilder.hpp"
#include "Type.h"
#include "codegen/MachineBlock.hpp"
#include <set>
#include <vector>
#include <map>
#include <iostream>

#ifndef COMPILER_BASICBLOCK_H
#define COMPILER_BASICBLOCK_H

class Instruction;
class Function;
class ValueRef;
class DomNode;

class BasicBlock {
public:
    std::string label;
    std::vector<BasicBlock *> pred,succ;
    std::vector<Instruction*> local_instr;

    std::string code;
    Function * func_belong;
    DomNode * domNode;

    std::set<ValueRef*> live_in;
    std::set<ValueRef*> live_out;

    std::set<ValueRef*> live_use;
    std::set<ValueRef*> live_def;

    BasicBlock(std::string& label,Function * func);

    BasicBlock(int t){
        this->label = std::to_string(t);
    }

    void appendCode(Instruction* instruction,std::string& code);

    void insertCodeAtFront(Instruction* instruction,std::string& code);

    void Emit();

    MachineBlock *mBlock;

    void codegen(AsmBuilder *builder,
                 std::map<std::string, int> &offset_table,
                 std::map<std::string, int> &size_table,
                 int framesize,
                 vector<Type*> &arguments,
                 bool is_entry = false);
};


#endif //COMPILER_BASICBLOCK_H
