#ifndef __MACHINE_BLOCK_H_
#define __MACHINE_BLOCK_H_

#include "codegen/MachineInstruction.hpp"
#include <memory>
#include <ostream>
#include <set>
#include <vector>

class MachineFunction;
class BasicBlock;

class MachineBlock {
public:
    BasicBlock *IRBlock;
    MachineFunction *parent;
    int no;
    std::vector<MachineBlock *> pred, succ;

    std::vector<MachineInstruction *> inst_list;

    std::set<std::string> live_in;
    std::set<std::string> live_out;

    std::set<std::string> live_use;
    std::set<std::string> live_def;

    int begin_no, end_no;

    static int label;

    BasicBlock *bb;

    MachineBlock(MachineFunction *parent_p, BasicBlock *IR_Block_p) : parent(parent_p), IRBlock(IR_Block_p) {}
    
    void insertInst(MachineInstruction *inst) {
        inst_list.push_back(inst);
        inst->parent = this;
    }
    
    void output(std::ostream &os) const;
};

#endif