#ifndef __MACHINE_FUNCTION_H_
#define __MACHINE_FUNCTION_H_

#include "codegen/MachineBlock.hpp"
#include "codegen/MachineInstruction.hpp"
#include "codegen/MachineOperand.hpp"
#include <iostream>
#include <map>
#include <memory>
#include <vector>
#include <cassert>

class MachineUnit;
class Function;

class MachineFunction {
public:
    MachineUnit *parent;
    std::vector<MachineBlock *> block_list;
    Function *IR_func;
    std::map<int, MachineInstruction *> no2inst;
    std::map<std::string, std::set<std::pair<int, int>>> live_ranges;
    std::map<std::string, std::pair<int, int>> live_intervals;
    int framesize{};

    MachineFunction(MachineUnit *parent_p, Function *func) : parent(parent_p), IR_func(func) {}

    void insert_block(MachineBlock *block) {
        block_list.push_back(block);
    }

    void output(std::ostream &os) {
        for (auto block : block_list) {
            block->output(os);
        }
    }

};

#endif