//
// Created by q1w2e3r4 on 23-7-25.
//

#include "HIR-opt/HOptimizer.h"
#include "HIR-opt/DomTreePass.h"
#include "HIR-opt/LiveVariableAnalysis.h"
#include "HIR-opt/Mem2RegPass.h"

HOptimizer::HOptimizer(GlobalUnit *gu) {
    this->globalUnit = gu;
}

void HOptimizer::Optimize() {
    // Dom Tree & DF
    DomTreePass* pass1 = new DomTreePass(this->globalUnit);
    pass1->run();

    //LVA
    LiveVariableAnalysis* lva = new LiveVariableAnalysis(this->globalUnit);

    lva->analysis();
    //lva->listDefUse();
    //lva->listInOut();

    // Mem2reg
    Mem2RegPass* mem2reg = new Mem2RegPass(this->globalUnit);
    mem2reg->run();

    //cout << "after opt:" << endl;
    this->globalUnit->Emit();
}
