#include "MyVisitor.h"
#include "Type.h"
#include <initializer_list>
#include <memory>

vector<sylib_func_t> sylib_funcs{
    //   funcName               retType     paramsType
    {"getint"s,             INT32TYPE,  {}},
    {"getch"s,              INT32TYPE,  {}},
    {"getfloat"s,           FLOATTYPE,  {}},
    {"getarray"s,           INT32TYPE,  {POINTERTYPE}},
    {"getfarray"s,          INT32TYPE,  {POINTERTYPE}},

    {"putint"s,             VOIDTYPE,   {INT32TYPE}},
    {"putch"s,              VOIDTYPE,   {INT32TYPE}},
    {"putarray"s,           VOIDTYPE,   {INT32TYPE, POINTERTYPE}},
    {"putfloat"s,           VOIDTYPE,   {FLOATTYPE}},
    {"putfarray"s,          VOIDTYPE,   {INT32TYPE, POINTERTYPE}},

    {"putf"s,              VOIDTYPE,   { /* TODO */}},
    {"before_main"s,       VOIDTYPE,   {}},
    {"after_main"s,        VOIDTYPE,   {}},
    {"_sysy_starttime"s,   VOIDTYPE,   {INT32TYPE}},
    {"_sysy_stoptime"s,    VOIDTYPE,   {INT32TYPE}},
};

void MyVisitor::add_sylib_func() {
    for (auto &func : sylib_funcs) {
        globalUnit->addFunc(func._funcName, new Type(func._retType), std::move(func._paramsTypes));
    }
}