pass_num=0
test_num=0

testcases=$(find functional -name "*.sy" | sort)
for sysy_filename in ${testcases}
do
    if (( test_num == 55 )); then
        break
    fi
    echo "${test_num}: ${sysy_filename}"
    input_file="${sysy_filename%.sy}.in"
    rm ans answer.txt
    if [ -f out ]; then
        rm out
    fi
    if [ -f output.txt ]; then
        rm output.txt
    fi
    if [ -f out.s ]; then
        rm out.s
    fi

    echo "#include \"../sylib/sylib.c\"" > sample.c  #普通定向，清空原内容
    cat ${sysy_filename} >> sample.c                  #重定向

    gcc sample.c -w -o ans
    if [ -f $input_file ]; then
        ./ans < $input_file > answer.txt
    else
        ./ans > answer.txt
    fi
    echo $? >> answer.txt

    timeout 10 ../build/compiler ${sysy_filename} > /dev/null
    riscv64-unknown-linux-gnu-gcc -march=rv64gc out.s ../sylib/sylib.c -o out
    if [ -f $input_file ]; then
        qemu-riscv64 out < $input_file > output.txt
    else
        qemu-riscv64 out > output.txt
    fi
    echo $? >> output.txt

    echo -e "\e[33mAnswer:\e[0m"
    cat answer.txt
    echo -e "\e[33mOutput:\e[0m"
    cat output.txt

    diff answer.txt output.txt > /dev/null
    if [ $? == 0 ]; then
        ((pass_num++))
        echo -e "\e[32mPass\e[0m"
    else
        echo -e "\e[31mWA\e[0m $sysy_filename"
    fi
    if [[ "$1" == "d" ]]; then
        read
    fi
    echo
    ((test_num++))
done

echo "Pass cases ($pass_num/$test_num)"
